//-------------------------------------------------------------------------------------------------
// t@CFCMesh.cpp
// @@@eFt@CIuWFNgNX̒`
// X@V@FKenji.Ohishi 2009.11.12
//-------------------------------------------------------------------------------------------------
#include "CMesh.h"

//-------------------------------------------------------------------------------------------------
// ֐F	CMesh::CMesh()
// T  vF	RXgN^@
// @F Ȃ
//-------------------------------------------------------------------------------------------------
CMesh::CMesh()
{
	pMesh = NULL;	//bVIuWFNg|C^ 
	pMat = NULL;	// }eA
	pTex = NULL;	// eNX`
	dwCnt = 0;		// TuZbgJEg
}

//-------------------------------------------------------------------------------------------------
// ֐F	CMesh::~CMesh()
// T  vF	fXgN^
// @F Ȃ	
//-------------------------------------------------------------------------------------------------
CMesh::~CMesh()
{
	Release();
}

//-------------------------------------------------------------------------------------------------
// ֐F	CMesh::Release();
// T  vF	bVIuWFNg̊J
// @F	Ȃ
//-------------------------------------------------------------------------------------------------
void CMesh::Release()
{

	if(pMesh != NULL){
		pMesh->Release();
		pMesh = NULL;
	}

	for(DWORD i = 0 ; i < dwCnt ; i++){
		if(pTex[i] != NULL){
			pTex[i]->Release();
			pTex[i] = NULL;
		}
	}

}

//-------------------------------------------------------------------------------------------------
// ֐F	CMesh::Load(char *name , LPDIRECT3DDEVICE9 d);
// T  vF	tHgIuWFNg̐
//   F	nameFt@C , dF`foCX
//-------------------------------------------------------------------------------------------------
void CMesh::Load(char *name , LPDIRECT3DDEVICE9 d)
{

	LPD3DXBUFFER	pBuff = NULL;	// obt@
	HRESULT			hr;

	hr = D3DXLoadMeshFromX
	(
		name,
		D3DXMESH_SYSTEMMEM, 
		d,
		NULL, 
		&pBuff,
		NULL,
		&dwCnt, 
		&pMesh
    );
	if(FAILED( hr )){
		MessageBox(NULL,"Xfile Not Found",name,MB_OK);
	}

	if (!(pMesh->GetFVF()&D3DFVF_NORMAL)) {
		pMesh->CloneMeshFVF( pMesh->GetOptions() , pMesh->GetFVF() | D3DFVF_NORMAL , d , &pMesh);
		D3DXComputeNormals(pMesh, NULL);
	} else {
		pMesh->AddRef();
	}
	
	D3DXMATERIAL* d3dxMaterial = (D3DXMATERIAL *)pBuff->GetBufferPointer();
	pMat = new D3DMATERIAL9 [ dwCnt ];
	pTex = new LPDIRECT3DTEXTURE9 [ dwCnt ];

	for ( DWORD i = 0; i < dwCnt; i++ ){
		pMat[i]         = d3dxMaterial[i].MatD3D;
		pMat[i].Ambient = pMat[i].Diffuse;
		pTex[i]         = NULL;

		LPCTSTR tex_name = d3dxMaterial[i].pTextureFilename;

		if( tex_name && lstrlen(tex_name) > 0 )
		{
			if( FAILED( D3DXCreateTextureFromFile(d,tex_name,&pTex[i]) ) ) 
				continue;
		}

	}

	pBuff->Release();

	ComputeBoundingSphere();
	ComputeBoundingBox();

}

//-------------------------------------------------------------------------------------------------
// ֐F	CMesh::ComputeBoundingSphere()
// T  vF	ĚvZ
//   F	Ȃ
//-------------------------------------------------------------------------------------------------
void CMesh::ComputeBoundingSphere(){

	LPDIRECT3DVERTEXBUFFER9 pVB = NULL;
	void* pVertices = NULL;

	pMesh->GetVertexBuffer( &pVB );

	pVB->Lock( 0, 0, &pVertices, 0);

	// E̒SWƔa擾
	D3DXComputeBoundingSphere(
		(D3DXVECTOR3*)pVertices,
		pMesh->GetNumVertices(),
		D3DXGetFVFVertexSize( pMesh->GetFVF() ),
		&vecCenter,
		&fRad);

	pVB->Unlock();

	pVB->Release();
	pVB = NULL;

}

//-------------------------------------------------------------------------------------------------
// ֐F	CMesh::ComputeBoundingBox()
// T  vF	E{bNX̌vZ
//   F	Ȃ
//-------------------------------------------------------------------------------------------------
void CMesh::ComputeBoundingBox(){

	LPDIRECT3DVERTEXBUFFER9 pVB			= NULL;
	void*					pVertices	= NULL;

	pMesh->GetVertexBuffer( &pVB );

	pVB->Lock( 0, 0, &pVertices, 0);

	// E{bNX̂E̍W擾
	D3DXComputeBoundingBox(
		(D3DXVECTOR3*)pVertices,
		pMesh->GetNumVertices(),
		D3DXGetFVFVertexSize( pMesh->GetFVF() ),
		&min,
		&max);

	pVB->Unlock();

	pVB->Release();
	pVB = NULL;

}


//-------------------------------------------------------------------------------------------------
// ֐F	CMesh::SetMaterial(D3DCOLORVALUE Diffuse, DWORD matNo)
// T  vF	wt@C̃}eAf[^Zbg
//   F	DiffuseFfBt[YJ[
//   F	matNo  F}eAio[
//-------------------------------------------------------------------------------------------------
void CMesh::SetMaterial(D3DCOLORVALUE Diffuse, DWORD matNo)
{
	pMat[matNo].Diffuse = Diffuse;
}

//-------------------------------------------------------------------------------------------------
// ֐F	CMesh::Setalfa(float alfa, DWORD matNo)
// T  vF	lZbg
//   F	alfa   Fl
//   F	matNo  F}eAio[
//-------------------------------------------------------------------------------------------------
void CMesh::Setalfa(float alfa, DWORD matNo)
{
	pMat[matNo].Diffuse.a = alfa;
}

//-------------------------------------------------------------------------------------------------
// ֐F	CMesh::Draw(LPDIRECT3DDEVICE9 d)
// T  vF	bV̕\
//   F	dF`foCX
//-------------------------------------------------------------------------------------------------
void CMesh::Draw(LPDIRECT3DDEVICE9 d)
{
	d->SetRenderState( D3DRS_LIGHTING,TRUE);	// CeBOnm

	for(DWORD i = 0 ; i < dwCnt ; i++){
		d->SetMaterial( &pMat[i] );				// i|SɃ}eAZbg
		d->SetTexture( 0, pTex[i] );			// i|SɃeNX`Zbg
		pMesh->DrawSubset(i);					// bVTuZbg̕`
	}
}

//-------------------------------------------------------------------------------------------------
// ֐F	CMesh::Draw(LPDIRECT3DDEVICE9 d ,LPD3DXEFFECT Effect)
// T  vF	bV̕\(GtFNg)
//   F	dF`foCX
//   F	GtFNg|C^
//-------------------------------------------------------------------------------------------------
void CMesh::Draw(LPDIRECT3DDEVICE9 d ,LPD3DXEFFECT Effect)
{

	for(DWORD i = 0 ; i < dwCnt ; i++){

		// FAeNX`(fx̃O[oŒ ėpȂ)
		D3DXVECTOR4 Diffuse = D3DXVECTOR4(pMat[i].Diffuse.r,pMat[i].Diffuse.g,pMat[i].Diffuse.b,pMat[i].Diffuse.a);
		Effect->SetVector("Diffuse", &Diffuse);
		Effect->SetTexture("MeshTex", pTex[i]);

		int texflg;
		texflg = (pTex[i] == NULL)? 0 : 1;
		
		// TuZbg̕`
		Effect->Begin(0, 0);
		Effect->BeginPass( texflg );

		pMesh->DrawSubset(i);

		Effect->EndPass();
		Effect->End();
	
	}

}

//-------------------------------------------------------------------------------------------------
// ֐F	CMesh::Mesh()
// T  vF	privateoԂANZT
// ߂lF	bV|C^
//-------------------------------------------------------------------------------------------------
LPD3DXMESH CMesh::GetMesh(){
	return pMesh;
}

//-------------------------------------------------------------------------------------------------
// ֐F	CMesh::GetCenter()
// T  vF	privateoԂANZT
// ߂lF	E̒SW
//-------------------------------------------------------------------------------------------------
D3DXVECTOR3 CMesh::GetCenter(){
	return vecCenter;
}

//-------------------------------------------------------------------------------------------------
// ֐F	CMesh::Radius()
// T  vF	privateoԂANZT
// ߂lF	E̔a
//-------------------------------------------------------------------------------------------------
float CMesh::GetRadius(){
	return fRad;
}

//-------------------------------------------------------------------------------------------------
// ֐F	CMesh::GetMin()
// T  vF	privateoԂANZT
// ߂lF	E{bNX̍ŏl
//-------------------------------------------------------------------------------------------------
D3DXVECTOR3 CMesh::GetBoxMin(){
	return min;	
}

//-------------------------------------------------------------------------------------------------
// ֐F	CMesh::GetMax()
// T  vF	privateoԂANZT
// ߂lF	E{bNX̍ől
//-------------------------------------------------------------------------------------------------
D3DXVECTOR3 CMesh::GetBoxMax(){
	return max;	
}